// Package imports:
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:sghi_core/afya_moja_core/afya_moja_core.dart';

part 'identifier.freezed.dart';
part 'identifier.g.dart';

@freezed
class Identifier with _$Identifier {
  factory Identifier({
    @JsonKey(name: 'id') String? id,
    @JsonKey(name: 'value') String? value,
    @JsonKey(name: 'type') IdentifierType? type,
  }) = _Identifier;

  factory Identifier.fromJson(Map<String, dynamic> json) =>
      _$IdentifierFromJson(json);

  factory Identifier.initial() => Identifier(
        id: UNKNOWN,
        value: UNKNOWN,
        type: IdentifierType.UNKNOWN,
      );
}
