// Package imports:

// Project imports:
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:sghi_core/afya_moja_core/afya_moja_core.dart';

part 'security_question.freezed.dart';
part 'security_question.g.dart';

@Freezed(makeCollectionsUnmodifiable: false)
class SecurityQuestion with _$SecurityQuestion {
  factory SecurityQuestion({
    @JsonKey(name: 'securityQuestionID') String? securityQuestionID,
    @JsonKey(name: 'questionStem') String? questionStem,
    @JsonKey(name: 'description') String? description,
    @JsonKey(name: 'responseType', defaultValue: SecurityQuestionResponseType.UNKNOWN)
        SecurityQuestionResponseType? responseType,
    @JsonKey(name: 'active') @Default(false) bool? active,
  }) = _SecurityQuestion;

  factory SecurityQuestion.fromJson(Map<String, dynamic> json) =>
      _$SecurityQuestionFromJson(json);

  factory SecurityQuestion.initial() => SecurityQuestion(
        securityQuestionID: UNKNOWN,
        questionStem: UNKNOWN,
        description: UNKNOWN,
        responseType: SecurityQuestionResponseType.UNKNOWN,
        active: false,
      );
}
