// Package imports:
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:sghi_core/afya_moja_core/src/constants.dart';
import 'package:sghi_core/afya_moja_core/src/domain/core/entities/contact.dart';

part 'user_data.freezed.dart';
part 'user_data.g.dart';

@Freezed(makeCollectionsUnmodifiable: false)
class UserData with _$UserData {
  factory UserData({
    @JsonKey(name: 'id') String? id,
    @JsonKey(name: 'username') String? userName,
    @JsonKey(name: 'termsAccepted', defaultValue: false) bool? termsAccepted,
    @JsonKey(name: 'active', defaultValue: false) bool? active,
    @JsonKey(name: 'suspended', defaultValue: false) bool? suspended,
    @JsonKey(name: 'isPhoneVerified', defaultValue: false)
        bool? isPhoneVerified,
    @JsonKey(name: 'contacts') Contact? primaryContact,
    @JsonKey(name: 'name') String? name,
    @JsonKey(name: 'currentOrganizationID') String? currentOrganizationID,
    @JsonKey(name: 'currentProgramID') String? currentProgramID,
    @JsonKey(name: 'acceptedTermsID') int? acceptedTermsID,
  }) = _UserData;

  factory UserData.fromJson(Map<String, dynamic> json) =>
      _$UserDataFromJson(json);

  factory UserData.initial() => UserData(
        id: UNKNOWN,
        userName: UNKNOWN,
        termsAccepted: false,
        active: false,
        primaryContact: Contact.initial(),
        name: UNKNOWN,
      );
}
