import 'package:sghi_core/flutter_graphql_client/i_flutter_graphql_client.dart';

/// Params used to configure synchronization of Matrix event
///
/// Used in the [synchronizeEvents] function
class SyncParams {
  SyncParams({
    required this.client,
    this.accessToken,
    this.fullState = false,
    this.fullSync = false,
    this.timeout = 10000,
    this.since,
    this.forceFull = false,
  });

  /// A token that identifies the currently logged in user
  final String? accessToken;

  /// Whether to fetch the full state of the server during this sync
  final bool? fullState;

  /// Whether a full sync is required
  final bool? fullSync;

  /// How long to keep the connection alive. The API will keep returning events
  /// as long as they are available for this period
  final int? timeout;

  /// A point in time from where to return events from. Used for subsequent calls
  final String? since;

  /// Whether to force a full sync
  final bool? forceFull;

  /// The client to use to synchronize the events
  final IGraphQlClient client;
}
